
exports.up = function(knex) {
     return knex.schema.createTable('correlation', function(t) {
        t.increments('id')
          .unsigned()
          .primary()
          .defaultTo(1);
        t.timestamp('created_at').defaultTo(knex.fn.now());
        t.string('fingerprint').notNullable();
        t.string('universe').notNullable();
        t.string('token_A').notNullable();
        t.string('token_B').notNullable();
        t.string('defects', 10000).notNullable();
        t.integer("defect_count").defaultTo(0);
        t.string('files');
        t.string('callstack');
      });
};

exports.down = function(knex) {
    return knex.schema.dropTable('correlation');
};
