"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var clientRateLimit_1 = require("./clientRateLimit");
var events_1 = require("events");
var backtraceApi_1 = require("./backtraceApi");
var backtraceClientOptions_1 = require("./model/backtraceClientOptions");
var backtraceReport_1 = require("./model/backtraceReport");
var backtraceResult_1 = require("./model/backtraceResult");
/**
 * Backtrace client
 */
var BacktraceClient = /** @class */ (function (_super) {
    __extends(BacktraceClient, _super);
    function BacktraceClient(clientOptions) {
        var _this = _super.call(this) || this;
        _this._memorizedAttributes = {};
        if (!clientOptions.endpoint) {
            throw new Error("Backtrace: missing 'endpoint' option.");
        }
        _this.options = __assign(__assign({}, new backtraceClientOptions_1.BacktraceClientOptions()), clientOptions);
        _this._backtraceApi = new backtraceApi_1.BacktraceApi(_this.getSubmitUrl(), _this.options.timeout);
        _this._clientRateLimit = new clientRateLimit_1.ClientRateLimit(_this.options.rateLimit);
        _this.registerHandlers();
        return _this;
    }
    /**
     * Memorize selected values from application.
     * Memorized attributes will be available in your next Backtrace report.
     * Memorized attributes will be only available for one report.
     * @param key attribute key
     * @param value attribute value
     */
    BacktraceClient.prototype.memorize = function (key, value) {
        this._memorizedAttributes[key] = value;
    };
    /**
     * Clear all saved attributes
     */
    BacktraceClient.prototype.clearMemorizedAttributes = function () {
        this._memorizedAttributes = {};
    };
    /**
     * Returns all memorized attributes without clearing them.
     */
    BacktraceClient.prototype.checkMemorizedAttributes = function () {
        return this._memorizedAttributes;
    };
    BacktraceClient.prototype.createReport = function (payload, reportAttributes, fileAttachments) {
        if (reportAttributes === void 0) { reportAttributes = {}; }
        if (fileAttachments === void 0) { fileAttachments = []; }
        this.emit('new-report', payload, reportAttributes);
        var attributes = this.combineClientAttributes(reportAttributes);
        var report = new backtraceReport_1.BacktraceReport(payload, attributes, fileAttachments);
        report.setSourceCodeOptions(this.options.tabWidth, this.options.contextLineCount);
        return report;
    };
    /**
     * Send report asynchronously to Backtrace
     * @param payload report payload
     * @param reportAttributes attributes
     * @param fileAttachments file attachments paths
     */
    BacktraceClient.prototype.reportAsync = function (payload, reportAttributes, fileAttachments) {
        if (reportAttributes === void 0) { reportAttributes = {}; }
        if (fileAttachments === void 0) { fileAttachments = []; }
        return __awaiter(this, void 0, void 0, function () {
            var report, limitResult, result;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        report = this.createReport(payload, reportAttributes, fileAttachments);
                        this.emit('before-send', report);
                        limitResult = this.testClientLimits(report);
                        if (limitResult) {
                            return [2 /*return*/, limitResult];
                        }
                        return [4 /*yield*/, this._backtraceApi.send(report)];
                    case 1:
                        result = _a.sent();
                        this.emit('after-send', report, result);
                        return [2 /*return*/, result];
                }
            });
        });
    };
    /**
     * Send report synchronosuly to Backtrace
     * @param payload report payload - error or string
     * @param reportAttributes attributes
     * @param fileAttachments file attachments paths
     */
    BacktraceClient.prototype.reportSync = function (payload, reportAttributes, fileAttachments) {
        if (reportAttributes === void 0) { reportAttributes = {}; }
        if (fileAttachments === void 0) { fileAttachments = []; }
        var report = this.createReport(payload, reportAttributes, fileAttachments);
        return this.sendReport(report);
    };
    BacktraceClient.prototype.sendReport = function (report, callback) {
        var _this = this;
        this.emit('before-send', report);
        var limitResult = this.testClientLimits(report);
        if (limitResult) {
            return limitResult;
        }
        this._backtraceApi
            .send(report)
            .then(function (result) {
            if (callback) {
                callback(result.Error);
            }
            _this.emit('after-send', report, result);
        })
            .catch(function (err) {
            if (callback) {
                callback(err);
            }
        });
        return backtraceResult_1.BacktraceResult.Processing(report);
    };
    BacktraceClient.prototype.sendAsync = function (report) {
        return __awaiter(this, void 0, void 0, function () {
            var limitResult;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        this.emit('before-send', report);
                        limitResult = this.testClientLimits(report);
                        if (limitResult) {
                            return [2 /*return*/, limitResult];
                        }
                        return [4 /*yield*/, this._backtraceApi.send(report)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    BacktraceClient.prototype.testClientLimits = function (report) {
        if (this.samplingHit()) {
            this.emit('sampling-hit', report);
            return backtraceResult_1.BacktraceResult.OnSamplingHit(report);
        }
        var limitReach = this._clientRateLimit.skipReport(report);
        if (limitReach) {
            this.emit('rate-limit', report);
            return backtraceResult_1.BacktraceResult.OnLimitReached(report);
        }
        return undefined;
    };
    BacktraceClient.prototype.samplingHit = function () {
        return !!this.options.sampling && Math.random() > this.options.sampling;
    };
    BacktraceClient.prototype.getSubmitUrl = function () {
        var url = this.options.endpoint;
        if (url.includes('submit.backtrace.io')) {
            return url;
        }
        if (!this.options.token) {
            throw new Error('Token is required if Backtrace-node have to build url to Backtrace');
        }
        var uriSeparator = url.endsWith('/') ? '' : '/';
        return "" + this.options.endpoint + uriSeparator + "post?format=json&token=" + this.options.token;
    };
    BacktraceClient.prototype.combineClientAttributes = function (attributes) {
        if (attributes === void 0) { attributes = {}; }
        if (!attributes) {
            attributes = {};
        }
        return __assign(__assign(__assign({}, attributes), this.options.attributes), this.getMemorizedAttributes());
    };
    BacktraceClient.prototype.getMemorizedAttributes = function () {
        var result = this._memorizedAttributes;
        this._memorizedAttributes = {};
        return result;
    };
    BacktraceClient.prototype.registerHandlers = function () {
        var _this = this;
        this._backtraceApi.on('before-data-send', function (report, json) {
            _this.emit('before-data-send', report, json);
        });
        if (!this.options.disableGlobalHandler) {
            this.registerGlobalHandler(!!this.options.allowMultipleUncaughtExceptionListeners);
        }
        if (this.options.handlePromises) {
            this.registerPromiseHandler();
        }
    };
    BacktraceClient.prototype.registerPromiseHandler = function () {
        var _this = this;
        // workaround for existing issue in TypeScript
        process.on('unhandledRejection', function (err) {
            _this.emit('unhandledRejection', err);
            _this.reportAsync(err, undefined);
        });
    };
    BacktraceClient.prototype.registerGlobalHandler = function (multipleExceptionListener) {
        var _this = this;
        var listenerCount = process.listenerCount('uncaughtException');
        if (!multipleExceptionListener && listenerCount !== 0) {
            console.error('Backtrace: multiple "uncaughtException" listeners attached.');
            return;
        }
        process.on('uncaughtException', function (e) {
            _this.emit('uncaughtException', e);
            _this.reportSync(e);
            throw e;
        });
        if (!multipleExceptionListener) {
            process.on('newListener', function (eventName, listener) {
                if (eventName === 'uncaughtException') {
                    // handle worst scenario when someone want to add new uncaughtException listener
                    // tslint:disable-next-line: quotemark
                    var err = new Error("Backtrace: multiple 'uncaughtException' listeners attached.");
                    console.error(err.stack);
                    process.exit(1);
                }
            });
        }
    };
    return BacktraceClient;
}(events_1.EventEmitter));
exports.BacktraceClient = BacktraceClient;
//# sourceMappingURL=backtraceClient.js.map